# 1. Напишіть функцію, яка визначає сезон за датою. Функція отримує стрінг у форматі
# "[день].[місяць]" (наприклад "12.01", "30.08", "1.11" і тд) і повинна повернути стрінг з відповідним сезоном,
# до якого відноситься ця дата ("літо", "осінь", "зима", "весна")
# 2. Напишіть функцію "Тупий калькулятор", яка приймає два числових аргументи і строковий, який відповідає за
# операцію між ними (+ - / *). Функція повинна повертати значення відповідної операції (додавання, віднімання,
# ділення, множення), інші операції не допускаються. Якщо функція оримала невірний тип данних для операції
# (не числа) або неприпустимий (невідомий) тип операції вона повинна повернути None і вивести повідомлення
# "Невірний тип даних" або "Операція не підтримується" відповідно.
# 3. Напишіть докстрінг для обох функцій


# 1.

def get_season(date_str: str) -> str:
    """
    Функція приймає стрінг з датою у форматі "[день].[місяць]" (наприклад "12.01", "30.08", "1.11" і тд)
    і повертає стрінг з назвою відповідного сезону ("літо", "осінь", "зима", "весна").
    """
    date_parts = date_str.split('.')
    day = int(date_parts[0])
    month = int(date_parts[1])
    if month == 12 or month <= 2:
        return 'зима'
    elif 3 <= month <= 5:
        return 'весна'
    elif 6 <= month <= 8:
        return 'літо'
    elif 9 <= month <= 11:
        return 'осінь'
    else:
        return 'Невірний формат дати'

# 2.
def stupid_calculator(num1: float, num2: float, operation: str) -> float or None:
    """
    Функція приймає два числових аргументи (num1 та num2) і стрінг з операцією (operation),
    яка може бути "+", "-", "*", або "/". Функція повертає результат відповідної операції між num1 та num2,
    або None і повідомлення про помилку, якщо передано неприпустимі аргументи.
    """
    if not isinstance(num1, (int, float)) or not isinstance(num2, (int, float)):
        print('Невірний тип даних')
        return None
    if operation == '+':
        return num1 + num2
    elif operation == '-':
        return num1 - num2
    elif operation == '*':
        return num1 * num2
    elif operation == '/':
        if num2 == 0:
            print('Ділення на нуль неможливе')
            return None
        else:
            return num1 / num2
    else:
        print('Операція не підтримується')
        return None